Real time status informations of CNC (C8)

1.1 IntroductionPAGEREF _Toc307404805 \h2

1.2 Overview 3

1.3 Description 4

1.3.1 D_CoveredDistance 4

1.3.2 D_CommandFeed, D_ActiveFeed 4

1.3.3 D_StopConditions 5

1.3.4 X_ProgramEnd 5

1.3.5 X_WaitErrorRemoval 5

1.3.6 X_InterpolationActive, X_DwellTimeActive 6

1.3.7 HLIBahnCoordDispData_Coord 6

1.3.8 HLISAddProgInfo_Data 6

1.3.9 Extended status information 7

1.3.9.1 X_SpeedLimitDetect, look ahead for speed limit 7

1.3.9.2 Description 8

1.4 Example 12

1.5 Parameters 15

1.5.1 Overview 15

1.5.2 Description 15

More:

button Introduction

button Overview

button Description

button Example

button Parameters


Introduction

Most CNC status signals and status information are of an informative nature and, to some extent, are provided to the user via display data or via the HMI.

Real-time status signals consists of information from the CNC's real-time area. The interpolator's status information is described below.

In most cases, this consists of information about the CNC's operating mode such as active manual operation, active interpolation, program status and status information with regard to internal CNC processes, etc. which, of course, are naturally also helpful for diagnostic purposes.

The HMI or PLC can control or influence the internal status process by logical combination of status signals.

The CNC also provides status information with which specific machining technologies can be mastered better with the PLC's support. In the case of the speed look-ahead function, a status signal is generated which indicates in advance whenever a defined speed limit is fallen short of. Therefore, the power control of a burner, for examples, can be informed in good time.

The status information is made available to the PLC via the HLI. Therefore, the signals for status information described below can be found in the HLI interface.


Overview

This documentation lists only the most important status information that is valid at the interpolator level.

An extensive description of all available access or influencing possibilities can be found in the [HLI] documentation.

Status information | Meaning
D_CoveredDistance | Current block position or path distance
D_CommandFeed | Programmed feedrate (F word)
D_ActiveFeed | Current path feedrate
D_StopConditions | Current stop condition (bit-coded)
X_ProgramEnd | Program end reached (M30)
X_WaitErrorRemoval | Wait for error acknowledgement by user
X_InterpolationActive | Interpolation is active
X_AxesInPosition | Axis group is in position
X_WaitAxesInPosition | Wait until axes are in position
X_WaitTechnoAcknowledge | Wait for acknowledgement of PLC
X_WaitContinue | Wait for user continuation request
X_DwellTimeActive | Wait due to dwell time
X_BlockSearchActive | Interpolator block search active
X_SpeedLimitDetect | Below speed limit
HLIBahnCoordDispData_Coord | CNC coordinates and coordinate system
HLISAddProgInfo_Data | Additional program information


Description

More:

button D_CoveredDistance

button D_CommandFeed, D_ActiveFeed

button D_StopConditions

button X_ProgramEnd

button X_WaitErrorRemoval

button X_InterpolationActive, X_DwellTimeActive

button HLIBahnCoordDispData_Coord

button HLISAddProgInfo_Data

button Extended status information


D_CoveredDistance

This variable contains the permille value of current position in the motion block sd(t) of length s. The distance in space results from the distance components of the main axes or one single axis. Within one motion block, the value sd always varies within the range of 0 < D_CoveredDistance < 1000.


D_CommandFeed, D_ActiveFeed

The D_CommandFeed variable contains the path feedrate programmed via the F word. D_ActiveFeed is the current path feedrate in the block.


D_StopConditions

In bit-coded form, this contains the stop conditions which, by means of NC programming or PLC commanding, lead to motion stopping or to stopping of program execution in the interpolator.

Stop condition | Status bit
Feed hold | 0x0000 0001
Axis-specific feed rate enabling not available | 0x0000 0002
Single step mode active | 0x0000 0004
Wait for PLC acknowledgement | 0x0000 0020
Wait due to M00, M01 | 0x0000 0010
Override 0 | 0x0000 0040
Dwell time | 0x0000 0200
Channel synchronisation active | 0x0000 0800
IPO input FIFO empty | 0x0000 1000
Read-in enabling | 0x0000 2000
Wait for axes in the case of axis exchange | 0x0000 8000
Channel in the error state | 0x0001 0000


X_ProgramEnd

This status information indicates that the program end has been reached or that no NC program is currently being executed.


X_WaitErrorRemoval

This status is indicated in the event of a CNC error in the real-time area that can be removed by means of an NC reset (depending on the error reaction class).


X_InterpolationActive, X_DwellTimeActive

The X_InterpolationActive status is indicated if a part program with travel motions is in execution and if a travel block is currently being interpolated in the real-time part.

Program example:

................

N20 G01 X10 Y20 Z30 F2000 <- Block currently being
interpolated

...............

The X_DwellTimeActive status is indicated if a part program with dwell time is in execution and a block with a dwell time is currently being executed in the real-time part.

Program example:

................

N20 G04 10 <- Block with dwell time currently executed

...............


HLIBahnCoordDispData_Coord

This consists of the coordinates of the various coordinate systems that the CNC is able to provide to the outside world.


HLISAddProgInfo_Data

This consists of additional information that can be retrieved in relation to the NC program.


Extended status information

More:

button X_SpeedLimitDetect, look ahead for speed limit

button Description


X_SpeedLimitDetect, look ahead for speed limit

General

This function generates a CNC status signal depending on the motion blocks and the current path feedrate. It is mainly used for plasma cutting technology to deactivate distance control of the cutting head via the PLC if the speed drops below a certain limit. This occurs when decelerating before and accelerating after a corner, for example.

Therefore, the critical positions in the motion segment (corner) are defined by a speed limit.

Speed limit detect

The status flag speed limit detect to the PLC is set if the actual path velocity is below the given limit. The reduce of path velocity results of:

q Reduction of velocity at block transition because of a corner in the contour.

q Reduction of velocity because of override setting.

q Expected M-function acknowledgement at block transition.

q Look-Ahead reduces velocity becous of missing path to move (to less blocks).

Zone

In addition the signal can be set in advance or the clearing can be delayed. This amount of advance or delay can be given in time or in distance unit.

q Advance: The prepared velocity at block end is e.g. because of a geometrical corner below the given limit. The status flag is set in advance with the given amount (distance / time).

q Backlash: The velocity at block start already is below the limit value. The status flag will be cleared delayed if the velocity crosses the limit.

Clear

I.e. the status flag will be cleared if following conditions are reached:

q The actual path velocity is above the given limit.

q The path position is outside the given delay (time, distance).


Description

Activation | When the function is activated, according to the control flag P-CHAN-00017 a CNC status signal is generated which reports falling bellow a speed limit or the detection of a future falling bellow the speed limit.
Limit | The speed limits is defined via the percentage weighting (P-CHAN-00089) of the F word in the NC program.
Advance, delay | The expected reduce of velocity at block end can be reported in advance by the parameter P-CHAN-00013. Accordingly the clearing of the signal can be delayed by the parameter P-CHAN-00012. by the parameters P-CHAN-00012 and P-CHAN-00012 a kind of hysteresis can be defined.
Distance, time | The unit of the zone parameters (distance or time) is defined via the P-CHAN-00018 parameter. The CNC generates the speed limit detect status signal if the path position is within this zone. Figure 1-1: F word and "speed limit detected" status signal

Influence of override

The influencing of the speed limit via the real time feed override can be controled by the parameter P-CHAN-00155.

In default case the real time feed override does not influence the speed limit value P-CHAN-00089. The speed limit detect status signal is also set if the path feedrate weighted with the override drops below the speed limit P-CHAN-00089.

Because the override is an online-influence by the user/application the in advance setting or delayed clearing is not considered in this case.

Figure 1- 2 : Timing diagram without override weighting ( f_override_weight_v_limit = 0 )

If the parameter P-CHAN-00155 is set on 1, the parametrized speed limit value P-CHAN-00089 is weighted by the override value. This is desirable e.g. for the comissioning or the running in of contours. It has to be taken into account for non constant programmed feed, that the SLD signal is getting active each in acceleration phases, because at block beginning the speed limit is set on the new value.

Figure 1- 3 : Timing diagram with override weighting ( f_override_weight_v_limit = 1 )

Influence of technology functions

Waiting for PLC-
acknowledge

PLC-acknowledge during deceleration

The speed limit detect status signal is generated if the CNC has to stop and wait due to certain types of technology functions or missing PLC synchronisation. Also in this conditions the in advance setting or delayed clearing of the signal is considered.

Figure 1-4: Missing PLC acknowledgement and "speed limit detected" status signal

In the case of M functions of the MVS_SNS type, later synchronisation or M functions with look ahead, the CNC stops only if the PLC acknowledgement is missing. Restarting is possible again if the PLC's acknowledgement signal arrives before motion stopping.

Figure 1- 5 : Restarting after PLC acknowledgement resets the speed limit detect status signal.

Each M or H function of the MVS_SVS or MNS_SNS type always leads to motion stopping (see also [FCT-C1]).

Interruption of block supply

If the path feedrate fluctuates due to short blocks and inadequate block supply, this may lead to activation of the status signal speed limit detect.

In the example below, the distance from the corner and the distance to the corner parameters are set to 0 for the sake of simplification.

Figure 1-6: Inadequate block supply leads to activation of the "speed limit detected" signal.


Example

The IPO status signal speed limit detect is generated depending on the set parameters if the programmed contour leads to deceleration along the path with the speed dropping below the speed limit, e.g. due to a corner.

Parameters

Excerpt from the channel parameter list [CHAN]:

# Speed limit Look Ahead parameter definition

# ===========================================

speed_limit_look_ahead.f_enable 1

speed_limit_look_ahead.v_limit 750

speed_limit_look_ahead.f_time 0

speed_limit_look_ahead.dist_to_corner 10000

speed_limit_look_ahead.dist_from_corner 10000

speed_limit_look_ahead.f_override_weight_v_limit 0

By special variables (V.G.SPEED_LIMIT.*) the parameters also can be changed from NC program [PROG].

Program example

%main

X0 Y0

N10 G01 X50 F5000

N20 X100

N30 X150

N40 X200 (speed drop at the end of the NC block)

N50 X250 Y-25

N60 X300 Y-50

N70 X350 Y-75

N80 X400 Y-100

M30

The parameters listed above and the F word in the NC program result in:

Speed limit = 75% of the programmed feed

-> v_limit = 3750mm/min (62500um/s)

In the program example, the path feedrate drops due to a contour knee angle of 30 degrees to 8562um/s at the N40 -> N50 block transition, i.e. the speed limit detected status signal is set at a distance of 1mm before falling short of the speed limit at the block end N40 and 1mm after exceeding of the speed limit at the block start N50.

Abbildung 1-7: F Word and status signal speed limit detected


Parameters

More:

button Overview

button Description


Overview

ID | Parameter | Description
P-CHAN-00012 | dist_from_corner | Distance from corner
P-CHAN-00013 | dist_to_corner | Distance to corner
P-CHAN-00017 | f_enable | Enabling/disabling of the function
P-CHAN-00018 | f_time | Control flag for subsequent parameters, distance or time
P-CHAN-00089 | v_limit | Weighting value for speed limit
P-CHAN-00155 | f_override_weight_v_limit | Weighting the speed limit value by override


Description

P-CHAN-00012

Distance from corner

Parameter

speed_limit_look_ahead.dist_from_corner

Description

The P-CHAN-00012 parameter defines the distance after a corner. If you are within this distance, the speed limit detect status signal is active.

Depending on the P-CHAN-00018 parameter, the P-CHAN-00012 parameter is interpreted either as a time value or a distance.

Data type

UNS32

Data range

0 ≤ P-CHAN-00012 ≤ MAX (UNS32)

Dimension

Translatory: 0.1 μ m, μ s

Rotatory: -

Default

0

Remarks

-

P-CHAN-00013

Distance to corner

Parameter

speed_limit_look_ahead.dist_to_corner

Description

The P-CHAN-00013 parameter defines the distance before a corner. If you are within this distance, the speed limit detect status signal is active.

Depending on the P-CHAN-00018 parameter, the P-CHAN-00013 parameter is interpreted either as a time value or a distance.

Data type

UNS32

Data range

0 ≤ P-CHAN-00013 ≤ MAX (UNS32)

Dimension

Translatory: 0.1 μ m, μ s

Rotatory: -

Default

0

Remarks

-

P-CHAN-00017 | Enabling/disabling the path feedrate look ahead function
Parameter | speed_limit_look_ahead.f_enable
Description | The path feedrate look ahead function is enabled or disabled with the P-CHAN-00017 flag.
Data type | BOOLEAN
Data range | 0: Path feedrate look ahead function disabled 1: Path feedrate look ahead function enabled
Dimension | Translatory: - | Rotatory: -
Default | 0
Remarks | -

P-CHAN-00018 | Control flag for distance or time parameter
Parameter | speed_limit_look_ahead.f_time
Description | The P-CHAN-00012 and P-CHAN-00013 parameters can be interpreted either as a time value or as a distance.
Data type | BOOLEAN
Data range | 0: The P-CHAN-00012 and P-CHAN-00013 parameters are interpreted as a distance 1: The P-CHAN-00012 and P-CHAN-00013 parameters are interpreted as a time
Dimension | Translatory: - | Rotatory: -
Default | 0
Remarks | -

P-CHAN-00089 | Weighting value for speed limit
Parameter | speed_limit_look_ahead.v_limit
Description | The speed limit whose falling short of activates the speed limit detect status signal results from weighting of the programmed F word with the P-CHAN-00089 parameter. If the current speed drops below the limit v = vprog*v_limit/1000 the logical status signal speed limit detect 0-> 1 is generated.
Data type | UNS32
Data range | 0 ≤ P-CHAN-00089 ≤ 1000
Dimension | 0.1%
Default | 0
Remarks | -

P-CHAN-00155 | Weighting the speed limit value by override
Parameter | speed_limit_look_ahead.f_override_weight_v_limit
Description | The influencing of the speed limit P-CHAN-00089 via the real time feed override can be controled by this parameter.
Data type | BOOLEAN
Data range | 0: No weighting of P-CHAN-00089 1: Weighting of P-CHAN-00089 by override
Dimension | Translatory: - | Rotatory: -
Default | 0
Remarks | -